# -*- coding: utf-8 -*-
"""
Created on Mon Oct  4 11:31:26 2021

@author: gregory.viateau
"""

class File:
    def __init__(self, valeur=None, suivant=None):         
        self.valeur = valeur        
        self.suivant = suivant
        
    def enfiler(self, valeur):
        if self.est_vide():            
            self.suivant = File()            
            self.valeur =  valeur
        else: 
            cel = self
            while not cel.suivant.est_vide():
                cel = cel.suivant
            cel.suivant = File(valeur, File()) 
    
    def defiler(self):
        valeur = self.valeur        
        self.valeur = self.suivant.valeur          
        self.suivant  = self.suivant.suivant
        return valeur    
    
    def est_vide(self): 
        return self.suivant is None

    def lire_tete(self):
        "Méthode à utiliser uniquement pour la fonction fusionne"
        return self.valeur

def file_vide():
    return File()


if __name__ == '__main__':
    f = file_vide()
    f.enfiler(1)
    f.enfiler(2)
    f.enfiler(3)
    f.enfiler(4)
    