# -*- coding: utf-8 -*-
"""
Created on Mon Oct  4 11:40:55 2021

@author: gregory.viateau
"""

from classe_files import *

def copier(file):
    nfile = file_vide()
    tfile = file_vide() # file temporaire
    while not file.est_vide():
        sommet = file.defiler()
        nfile.enfiler(sommet)
        tfile.enfiler(sommet)
    while not tfile.est_vide():
        file.enfiler(tfile.defiler())
    return nfile

def minimum(file):
    mini = file.defiler()
    tfile = file_vide()
    tfile.enfiler(mini)
    while not file.est_vide():
        sommet = file.defiler()
        tfile.enfiler(sommet)
        if sommet < mini:
            mini = sommet
    while not tfile.est_vide():
        file.enfiler(tfile.defiler())
    return mini

def extraction_minimum(file):
    """
    renvoie le minimum et le supprime de la file
    Attention : cette fonction peut changer l'ordre
    des termes de la file.
    """
    mini = file.defiler()
    tfile = file_vide()
    while not file.est_vide():
        sommet = file.defiler()
        if sommet < mini:
            tfile.enfiler(mini)
            mini = sommet
        else:
            tfile.enfiler(sommet)
    while not tfile.est_vide():
        file.enfiler(tfile.defiler())
    return mini  

def trier(file):
    file_triee = file_vide()
    copie_file = copier(file)
    while not copie_file.est_vide():
        file_triee.enfiler(extraction_minimum(copie_file))
    return file_triee

def trier2(file):
    "Autre solution n'utilisant pas la fonction extraction_minimum"
    file_triee = file_vide()
    copie_file = copier(file)
    while not copie_file.est_vide():
        mini = minimum(copie_file)
        sommet = copie_file.defiler()
        while sommet != mini :
            copie_file.enfiler(sommet)
            sommet = copie_file.defiler()
        file_triee.enfiler(mini)
    return file_triee        
            

def fusionne(file1, file2):
    cfile1 = copier(file1)
    cfile2 = copier(file2)
    resfile = file_vide()
    while not cfile1.est_vide() and not cfile2.est_vide():
        if cfile1.lire_tete() < cfile2.lire_tete():
            resfile.enfiler(cfile1.defiler())
        else:
            resfile.enfiler(cfile2.defiler())
    while not cfile1.est_vide():
        resfile.enfiler(cfile1.defiler())
    while not cfile2.est_vide():
        resfile.enfiler(cfile2.defiler())
    return resfile
    
def fusionne(file1, file2):
    cfile1 = copier(file1)
    cfile2 = copier(file2)
    resfile = file_vide()
    while not cfile1.est_vide() or not cfile2.est_vide():
        if cfile1.est_vide():
            resfile.enfiler(cfile2.defiler())
        elif cfile2.est_vide():
            resfile.enfiler(cfile1.defiler())
        elif cfile1.lire_tete() < cfile2.lire_tete():
            resfile.enfiler(cfile1.defiler())
        else:
            resfile.enfiler(cfile2.defiler())
    return resfile  

if __name__ == '__main__':
    f = file_vide()
    f.enfiler(45)
    f.enfiler(12)
    f.enfiler(30)
    f.enfiler(50)
    f.enfiler(8)
    f.enfiler(12)
    f1 = file_vide()
    f1.enfiler(1)
    f1.enfiler(2)
    f1.enfiler(5)
    f1.enfiler(8)
    f1.enfiler(9)
    f2 = file_vide()
    f2.enfiler(3)
    f2.enfiler(4)
    f2.enfiler(7)
    f2.enfiler(11)
    f2.enfiler(12)   
    