# -*- coding: utf-8 -*-
"""
Created on Fri Oct  8 11:05:34 2021

@author: gregory.viateau
"""

def file_vide():
    return None

def defiler(file):
    return file[0], file[1]

def enfiler(file, valeur):
    if file is file_vide():
        return (valeur, file_vide())
    return (file[0], enfiler(file[1], valeur))

def est_vide(file):
    return file is None

def copier(file):
    "version itérative"
    nfile = file_vide()
    while not est_vide(file):
        val, file = defiler(file)
        nfile = enfiler(nfile, val)
    return nfile

def copier(file):
    "version récursive"
    if file is file_vide():
        return file_vide()
    val, file = defiler(file)
    return (val, copier(file))

def minimum(file):
    "version itérative"
    mini, file = defiler(file)
    while not est_vide(file):
        valeur, file = defiler(file)
        if valeur < mini:
            mini = valeur
    return mini
        
def minimum(file):
    "version récursive"
    mini, file = defiler(file)
    if est_vide(file):
        return mini
    else:
        return min(mini, minimum(file))

if __name__ == '__main__':
    f = file_vide()
    f = enfiler(f, 1)
    f = enfiler(f, 2)
    f = enfiler(f, 3)
    f = enfiler(f, 4)





