from pile import *

def file_vide():
    A = pile_vide()
    B = pile_vide()
    return A, B

def enfiler(file, elt):
    A, B = file
    empiler(A, elt)

def defiler(file):
    A, B = file
    if B.est_vide():
        while not A.est_vide():
            empiler(B, depiler(A))
    return depiler(B)

def est_vide(file):
    A, B = file
    return A.est_vide() and B.est_vide()
    
    
if __name__ == '__main__':
    # script de test
    f = file_vide()
    enfiler(f, 1)
    enfiler(f, 2)
    enfiler(f, 3)
    print(defiler(f))
    enfiler(f, 4)
    while not est_vide(f):
        print(defiler(f))
    
    
    
