# -*- coding: utf-8 -*-
"""
Created on Fri Oct  1 10:54:24 2021

@author: gregory.viateau
"""

from classe_piles import *

def inverser(pile):
    npile = pile_vide()
    pile_temp = pile_vide()
    while not pile.est_vide():
        sommet = pile.depiler()
        npile.empiler(sommet)
        pile_temp.empiler(sommet)
    while not pile_temp.est_vide():
        pile.empiler(pile_temp.depiler())
    return npile

def copier(pile):
    npile = pile_vide()
    pile_temp = pile_vide()
    while not pile.est_vide():
        pile_temp.empiler(pile.depiler())
    while not pile_temp.est_vide():
        sommet = pile_temp.depiler()
        pile.empiler(sommet)
        npile.empiler(sommet)
    return npile

def parenthesage(chaine):
    pile = pile_vide()
    for c in chaine:
        if c in ['(', '[', '{']:
            empiler(pile, c)
        elif c in [')', ']', '}']:
            if est_vide(pile):
                return False
            d = depiler(pile)
            if (d, c) not in [('(',')'), ('[',']'), ('{','}')]:
                return False
    if est_vide(pile):
        return True
    else:
        return False


def switch(pile):
    if est_vide(pile):
        return pile_vide()
    npile = pile_vide()
    tpile = pile_vide()         # pile temporaire
    empiler(npile, depiler(pile))
    if est_vide(pile):          # cas pile à un élément
        return npile
    while not est_vide(pile):
        empiler(tpile, depiler(pile))
    nsommet = depiler(tpile)
    while not est_vide(tpile):
        empiler(npile, depiler(tpile))
    empiler(npile, nsommet)
    return npile


if __name__ == '__main__':
    p = pile_vide()
    p.empiler(1)
    p.empiler(2)
    p.empiler(3)
    p.empiler(4)